"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var createChangeSet_1 = require("./createChangeSet");
var executeChangeSet_1 = require("./executeChangeSet");
var printChangeSet_1 = require("./printChangeSet");
var getChangeSet_1 = require("./utils/getChangeSet");
var waitForChangeSet_1 = require("./utils/waitForChangeSet");
var DOC_SUFFIX = "For examples check Serverless-Cloudformation-StackManager readme";
var PLUGIN_NAME = 'serverlessCloudformationStackManager';
var USE_CHANGE_SETS = 'useChangeSets';
var CHANGE_SET_NAME_KEY = 'changeSetName';
var commonOptions = {
    'changeSetName': {
        usage: 'name of the change set which will be executed' +
            '(e.g. "--changeSetName \'add_lambda_change_set\'" or "-n \'add_lambda_change_set\'")',
        shortcut: 'n',
        type: 'string'
    },
    'waitTime': {
        usage: 'defines in seconds how long to wait for complete status. Defaults to 90' +
            '(e.g. "--waitTime 40',
        type: 'number',
        "default": 90
    },
    'tableWidth': {
        usage: 'defines width of the table outputted while printing the change set (if too small then it will wrap the table)'
    }
};
var ServerlessCloudformationStackManager = /** @class */ (function () {
    function ServerlessCloudformationStackManager(serverless, options) {
        var _a;
        var _this = this;
        this.executeChangeSet = function () {
            var options = _this.getFinalOptions();
            return (0, executeChangeSet_1.executeChangeSet)(_this.serverless, _this.provider, options);
        };
        this.printChangeSet = function () { return __awaiter(_this, void 0, void 0, function () {
            var options, changeSet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = this.getFinalOptions();
                        if (!options.changeSetName) {
                            throw new Error("changeSetName not set. Set it by passing --changeSetName param or by setting changeSetName in serverless.yml. " + DOC_SUFFIX);
                        }
                        return [4 /*yield*/, (0, waitForChangeSet_1.waitForChangeSet)(this.provider, options.changeSetName, options.waitTime)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, (0, getChangeSet_1.getChangeSet)(this.provider, options.changeSetName)];
                    case 2:
                        changeSet = _a.sent();
                        return [2 /*return*/, (0, printChangeSet_1.printChangeSet)(changeSet, { tableWidth: options.tableWidth })];
                }
            });
        }); };
        this.lockStackDeployment = function () {
            if (!_this.isUsingChangeSets()) {
                return;
            }
            console.log('Change sets are in usage. Preventing deploy.');
            // @ts-ignore
            _this.shouldNotDeployOriginalValue = _this.serverless.service.provider.shouldNotDeploy;
            // @ts-ignore
            _this.serverless.service.provider.shouldNotDeploy = true;
        };
        this.unlockStackDeployment = function () {
            if (!_this.isUsingChangeSets()) {
                return;
            }
            // @ts-ignore
            _this.serverless.service.provider.shouldNotDeploy = _this.shouldNotDeployOriginalValue;
            var changeSetName = _this.getChangeSetName();
            return (0, createChangeSet_1.createChangeSet)(_this.serverless, _this.provider, _this.options, changeSetName);
        };
        this.getFinalOptions = function () {
            var options = __assign({}, _this.options);
            var changeSetName = _this.serverless.service.initialServerlessConfig[PLUGIN_NAME][CHANGE_SET_NAME_KEY];
            if (changeSetName) {
                options.changeSetName = changeSetName;
            }
            return options;
        };
        this.isUsingChangeSets = function () { return _this.serverless.service.initialServerlessConfig[PLUGIN_NAME][USE_CHANGE_SETS]; };
        this.getChangeSetName = function () { return _this.serverless.service.initialServerlessConfig[PLUGIN_NAME][CHANGE_SET_NAME_KEY]; };
        this.provider = serverless.getProvider('aws');
        this.serverless = serverless;
        this.options = options;
        // For reference on JSON schema, see https://github.com/ajv-validator/ajv
        serverless.configSchemaHandler.defineTopLevelProperty(PLUGIN_NAME, {
            type: 'object',
            properties: (_a = {},
                _a[USE_CHANGE_SETS] = { type: 'boolean' },
                _a[CHANGE_SET_NAME_KEY] = { type: 'string' },
                _a),
            required: [USE_CHANGE_SETS],
            additionalProperties: false
        });
        this.commands = {
            'execute-change-set': {
                usage: 'Execute specified cloudformation change set',
                lifecycleEvents: ['run'],
                options: __assign({}, commonOptions)
            },
            'print-change-set': {
                usage: 'Outputs specified cloudformation change set',
                lifecycleEvents: ['run'],
                options: __assign({}, commonOptions)
            }
        };
        this.hooks = {
            'before:aws:deploy:deploy:createStack': function () { return console.log("Before createStack", _this.serverless.service.provider.shouldNotDeploy); },
            'after:aws:deploy:deploy:createStack': function () { return console.log("After createStack", _this.serverless.service.provider.shouldNotDeploy); },
            'before:aws:deploy:deploy:uploadArtifacts': function () { return console.log("Before upload", _this.serverless.service.provider.shouldNotDeploy); },
            'after:aws:deploy:deploy:uploadArtifacts': function () { return console.log("After upload", _this.serverless.service.provider.shouldNotDeploy); },
            'before:aws:deploy:deploy:updateStack': this.lockStackDeployment,
            'after:aws:deploy:deploy:updateStack': this.unlockStackDeployment,
            'execute-change-set:run': this.executeChangeSet,
            'print-change-set:run': this.printChangeSet
        };
    }
    return ServerlessCloudformationStackManager;
}());
module.exports = ServerlessCloudformationStackManager;
